// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Standard
#include <iostream>

// STL
#include <string>

#include <anna/core/functions.hpp>
#include <anna/core/core.hpp>
#include <anna/core/RuntimeException.hpp>
#include <anna/core/tracing/TraceLevelChecker.hpp>
#include <anna/core/tracing/Configuration.hpp>



using namespace anna;
using namespace anna::tracing;

void _exit(const std::string & msg) {
   std::cout << std::endl << msg << std::endl;
   exit(-1);
}

void test(const std::string & value) throw() {
   LOGINFORMATION(
      std::string msg = "Starting test for ";
      msg += value;
      Logger::information(msg , ANNA_FILE_LOCATION);
   );
   anna::tracing::TraceLevelChecker tlc(value.c_str());
   LOGDEBUG(Logger::debug("Enabled tracing ?", ANNA_FILE_LOCATION));
   LOGINFORMATION(
      std::string msg = "Finishing test for ";
      msg += value;
      Logger::information(msg , ANNA_FILE_LOCATION);
   );
}

int main(int argc, char** argv) {
   Logger::setLevel(Logger::Information);
//   Logger::setLevel(Logger::Debug);
   Logger::initialize("selectiveTracing", new TraceWriter("file.trace", 2048000));
   anna::tracing::Configuration & conf = anna::tracing::Configuration::instantiate();
   LOGINFORMATION(Logger::information("Blue Trigger", ANNA_FILE_LOCATION));
   conf.activateTraceTrigger("blue");
   test("red");
   test("blue");
   test("darkblue");
   conf.useRegexpForTraceTriggers();
   test("darkblue");
   test("green");
}

