// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Standard
#include <string>

// Project
#include <anna/core/core.hpp>
#include <anna/time/functions.hpp>

// Process
#include <rxSimpleTest.hpp>

// To calculate the current working directory and get an absolute path for traces:
#include <limits.h>
#include <unistd.h>


int main(int argc, const char** argv) {
  anna::Logger::setLevel(anna::Logger::Debug);

  // Current working directory and absolute trace path file:
  std::string trace_file = "./rxSimpleTest.trace";

  anna::Logger::initialize("rxSimpleTest", new TraceWriter(trace_file.c_str(), 2048000));
  anna::time::functions::initialize(); // before application instantiation (it have a anna::time object)
  anna::time::functions::setControlPoint(); // start control point (application lifetime)
  RxSimpleTest app;

  try {
    app.start();
  } catch(anna::Exception& ex) {
    std::cout << ex.asString() << std::endl;
  }

  return 0;
}

