// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/TraceMethod.hpp>

#include <anna/app/functions.hpp>
#include <anna/app/Application.hpp>

#include <anna/comm/Communicator.hpp>
#include <anna/comm/IndexedDelivery.hpp>
#include <anna/comm/CongestionController.hpp>

#include <anna/http/Request.hpp>

#include "Application.hpp"
#include "Request.hpp"
#include "Acceptor.hpp"
#include "Context.hpp"

using namespace std;
using namespace anna;
using namespace test;

void http4comm::Acceptor::initialize ()
   throw (RuntimeException)
{
}

void http4comm::Acceptor::evRequest (comm::ClientSocket& clientSocket, const http::Request& request)
   throw (RuntimeException)
{
   LOGMETHOD (TraceMethod tm ("http4comm::Acceptor", "evRequest", ANNA_FILE_LOCATION));

   comm::CongestionController& ccgg = comm::CongestionController::instantiate ();

   if (ccgg.getAdvice (clientSocket) == comm::CongestionController::Advice::Discard)
      return;

   const DataBlock& body = request.getBody ();

   if (body.getSize () == 0)
      throw RuntimeException ("La peticion no incorpora los parametros de operacion", ANNA_FILE_LOCATION);

   LOGINFORMATION (
      string msg ("Body recibido: ");
      msg += anna::functions::asString (body);
      Logger::information (msg, ANNA_FILE_LOCATION);
   );

   if (comm::Codec::getType (body) != Request::Id) 
      throw RuntimeException ("El mensaje recibido no es una peticion aritmetica", ANNA_FILE_LOCATION);

   int index;

   a_testRequest.decode (body);

   comm::IndexedDelivery* delivery = static_cast <Application&> (app::functions::getApp ()).getService ();

   try {
      switch (a_testRequest.op) {
         case '+': index = 0; break;
         case '-': index = 1; break;
         case '*': index = 2; break;
         case '/': index = 3; break;
      }
      delivery->prepare (index);
      delivery->send (a_testRequest);
      
      http4comm::Application& app = static_cast <http4comm::Application&> (app::functions::getApp ());      
      app.getContext ()->create (a_testRequest.initTime, clientSocket);
   }
   catch (RuntimeException& ex) {
      ex.trace ();
   }
}

