// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef timex_ArithmeticHTTPServer_Context_hpp
#define timex_ArithmeticHTTPServer_Context_hpp

#include <anna/timex/Context.hpp>

namespace anna {
   namespace comm {
      class ClientSocket;
   }
}

namespace test {

namespace http4comm {

class Transaction;

using namespace anna;

class Context : public anna::timex::Context <S64> {
public:
   Context (anna::timex::Engine&, const Millisecond& timeout);
   
   void create (const S64 id, comm::ClientSocket&) throw (RuntimeException);
   void destroy (Transaction*) throw ();

private:
   Recycler <Transaction> a_transactions;

   anna::timex::Transaction* createTransaction (const int /*classType*/) throw ();
   void releaseTransaction (anna::timex::Transaction* tt) throw ();

   std::string identifierAsString (const S64&) const throw ();
   const S64& contextAsIdentifier (const void*) const throw ();
   
   Context (const Context&);
};

}
}

#endif
