// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_dbms_mysql_InputBind_hpp
#define anna_dbms_mysql_InputBind_hpp

#include <anna/dbms/InputBind.hpp>

#include <anna/dbms.mysql/BaseBind.hpp>

namespace anna {

class DataBlock;

namespace dbms {

class Data;
class Statement;

namespace mysql {

class Statement;

class InputBind : public dbms::InputBind, public BaseBind {
public:
  InputBind(const char* name, dbms::Data& data);
  virtual ~InputBind();

private:
  void code() const throw(RuntimeException);

  void codeShortBlock(dbms::Data&) throw();
  void codeDate(dbms::Data&) throw();

  static char asCharacter(const char byte)
  throw() {
    return (byte >= 0 && byte <= 9) ? (byte + '0') : ((byte - 0xa) + 'A');
  }

  /* Funciones virtuales puras */
  void prepare(anna::dbms::Statement*, anna::dbms::Connection*, const int pos) throw(RuntimeException);
  void release(anna::dbms::Statement*) throw() {;}

  friend class mysql::Statement;
};

}
}
}

#endif

