// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_tme_codectypes_Unsigned16_hpp
#define anna_diameter_helpers_tme_codectypes_Unsigned16_hpp


// Local
#include <anna/diameter/codec/basetypes/OctetString.hpp>

#include <anna/config/defines.hpp>


namespace anna {

namespace diameter {

namespace codec {
class Avp;
}

namespace helpers {

namespace tme {

namespace codectypes {

/**
* Diameter Unsigned16 container
*/
class Unsigned16 : codec::basetypes::OctetString {

  U16 a_value;


  // Only for derived diameter type:
  void updateBasic() throw(anna::RuntimeException);
  void setPrintableString(const char * printableString) throw(anna::RuntimeException);

public:


  // Class-specific ////////////////////////////////////////////////////////////////////////////////////
  //
  /**
  * Gets the Unsigned16 value
  *
  * @return Unsigned16 value
  */
  const U16& getValue() const throw() { return a_value; }

  /**
  * Sets the Unsigned16 value
  *
  * @param value Unsigned16 value
  */
  void setValue(const U16& value) throw() { a_value = value; updateBasic(); }
  //
  //////////////////////////////////////////////////////////////////////////////////////////////////////


  // gets

  std::string getFormatName() const throw() { return "Unsigned16"; }


  // helpers

  std::string asPrintableString() throw(anna::RuntimeException) {
    return anna::functions::asString(a_value);
  }

  std::string asString() throw(anna::RuntimeException) {
    return asPrintableString();
  }


  // sets

  void decode(const char* buffer, const int size) throw(anna::RuntimeException);


  // exports /////////////////////////////
  using AvpData::getSize;
  using AvpData::code;
  //using OctetString::asPrintableString;
  using AvpData::asDataBlockString;
  //using OctetString::asString;
  using AvpData::asHexString;
  //using OctetString::decode;
  using AvpData::fromPrintableString;
  using AvpData::fromHexString;
};

}
}
}
}
}

#endif
