// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_html_Parser_hpp
#define anna_html_Parser_hpp

#include <anna/xml/Parser.hpp>

#include <anna/html/Node.hpp>

namespace anna {

namespace html {
/**
   Analizador de documentos HTML.

   Analiza la expresion contenida en un documento HTML y devuelve un arbol de nodos que resulta muy
   facil de usar.
*/
class Parser : public xml::Parser {
public:
  /**
     Constructor.
  */
  Parser() { a_head = a_body = NULL; }

  /**
     Obtiene el nodo HEAD del documento HTML analizado. Si no esta establecido lanzara una excepcion.
     \return el nodo HEAD del documento HTML analizado.
     \warning
        \li Solo deberia ser llamado despues de Parser::apply.
        \li El nodo devuelto no puede ser usado despues de invocar al destructor de este Parser.
  */
  const html::Node* getHead() throw(RuntimeException);

  /**
     Obtiene el nodo BODY del documento HTML analizado. Si no esta establecido lanzara una excepcion.
     \return el nodo BODY del documento HTML analizado.
     \warning
        \li Solo deberia ser llamado despues de Parser::apply.
        \li El nodo devuelto no puede ser usado despues de invocar al destructor de este Parser.
  */
  const html::Node* getBody() throw(RuntimeException);

private:
  const html::Node* a_head;
  const html::Node* a_body;

  void reset() throw() { xml::Parser::reset(); a_head = a_body = NULL; }

};

}
}

#endif


