// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/comm/functions.hpp>

#include <anna/comm/INetAddress.hpp>
#include <anna/comm/Device.hpp>

#include <anna/xml/Node.hpp>
#include <anna/xml/Attribute.hpp>

using namespace std;
using namespace anna;

const comm::Device* comm::INetAddress::getDevice(const bool exceptionWhenNull) const
throw(RuntimeException) {
  if(a_device == NULL && exceptionWhenNull == true) {
    string msg(asString());
    msg += " | No device attached";
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  return a_device;
}

string comm::INetAddress::asString() const
throw() {
  string result("comm::INetAddress { ");
  result += functions::asString(a_device);
  return result += anna::functions::asString(" | Port: %d }", a_port);
}

string comm::INetAddress::serialize() const
throw() {
  in_addr_t inaddr = (a_device) ? a_device->getAddress() : 0;
  string result(Device::asString(inaddr));
  return result += anna::functions::asString(".%d", a_port);
}

xml::Node* comm::INetAddress::asXML(xml::Node* parent) const
throw(RuntimeException) {
  xml::Node* result = parent->createChild("comm.INetAddress");

  if(a_device != NULL)
    a_device->asAttribute(result);
  else
    result->createAttribute("Device", "<null>");

  result->createAttribute("Port", a_port);
  return result;
}

