// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <stdarg.h>
#include <stdio.h>
#include <syslog.h>

#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceLogger.hpp>
#include <anna/core/DataBlock.hpp>

using namespace anna;

void TraceLogger::initialize(const char* ident)
throw() {
  openlog(ident, LOG_PID | LOG_CONS | LOG_ODELAY | LOG_NOWAIT, LOG_LOCAL0);
}

void TraceLogger::do_write(int level, const char* message, ...)
throw() {
  va_list ap;
  int size;
  int nbytes;

  try {
    DataBlock& dataBlock(getDataBlock());
    const char* data(dataBlock.getData());
    size = dataBlock.getMaxSize();

    while(true) {
      va_start(ap, message);
      nbytes = vsnprintf(const_cast <char*>(data), size, message, ap);
      va_end(ap);

      if(nbytes >= size) {
        dataBlock.allocate(nbytes + 1);
        data = dataBlock.getData();
        size = dataBlock.getMaxSize();
        continue;
      }

      break;
    }

    // void syslog(int priority, const char *format, ...);
    syslog(level, "%s", data);
  } catch(Exception&) {
  }
}

