// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


//------------------------------------------------------------------------------
//--------------------------------------------------------------------- #include
//------------------------------------------------------------------------------


// Local
#include <anna/statistics/Meter.hpp>
#include <anna/statistics/Engine.hpp>
#include <anna/xml/xml.hpp>


using namespace anna::statistics;


//******************************************************************************
//------------------------------------------------------------------------------
//--------------------------------------------------------------- Meter::Meter()
//------------------------------------------------------------------------------

// Default Constructor
Meter::Meter(const std::string & name) : a_accumulator(name) {
  Engine& statsEngine = Engine::instantiate();
  a_single_accumulator_concept_id = statsEngine.addConcept(name, "ms", true);
}


Meter::~Meter() {
// LOGMETHOD (TraceMethod tttm ("anna::statistics::Meter", "Destructor", FILE_LOCATION));
}



//------------------------------------------------------------------------------
//------------------------------------------------------------- Meter::operator=
//------------------------------------------------------------------------------
const Meter & Meter::operator = (const Meter & meter) {
// LOGMETHOD (TraceMethod tttm ("anna::statistics::Meter", "operator=", FILE_LOCATION));
  // Avoid self copy: i.e., Meter a,b; a=&b; a=b; b=a;
  if(this == &meter) return (*this);

  a_meter = meter.a_meter;
  a_accumulator = meter.a_accumulator;
  a_single_accumulator_concept_id = meter.a_single_accumulator_concept_id;
  return (*this);
}



//------------------------------------------------------------------------------
//------------------------------------------------------------ Meter::asString()
//------------------------------------------------------------------------------
std::string Meter::asString(const int & numberOfDecimals) const throw() {
  std::string trace;
  trace =  "\n=====";
  trace += "\nMeter";
  trace += "\n=====\n\n";
  trace += a_accumulator.asString(numberOfDecimals);
  return (trace);
}


//------------------------------------------------------------------------------
//--------------------------------------------------------------- Meter::asXML()
//------------------------------------------------------------------------------
anna::xml::Node* Meter::asXML(anna::xml::Node* parent, const int & numberOfDecimals) const throw() {
  anna::xml::Node* result = parent->createChild("anna.statistics.Meter");
  return (a_accumulator.asXML(result, numberOfDecimals));
}
